#ifndef AC_HEADER
#define AC_HEADER

#include <stdio.h>
#include <vector>



class ac_encoder 
{
public:
	//FILE *fp;
	std::vector<int> * fp_buffer;
	long low;
	long high;
	long fbits;
	int buffer;
	int bits_to_go;
	long total_bits;
	int symbol;
};

class ac_decoder 
{
public:
	FILE *fp;
	long value;  //̾Ƴ..
	long low;
	long high;
	int buffer;
	int bits_to_go;
	int garbage_bits;
};

class ac_model
{
public: 
	int nsym;  //ɺ.....
	int *freq;  //..
	int *cfreq; //Ż 
	int adapt;//????
};

void ac_encoder_init (ac_encoder *, std::vector<int> * );
void ac_encoder_done (ac_encoder *);
void ac_decoder_init (ac_decoder *, const char *);
void ac_decoder_init (ac_decoder *, std::vector<int> *);
void ac_decoder_done (ac_decoder *);
void ac_model_init (ac_model *, int, int *, int);
void ac_model_done (ac_model *);
long ac_encoder_bits (ac_encoder *);
void ac_encode_symbol (ac_encoder *, ac_model *, int);
int ac_decode_symbol (ac_decoder *, ac_model *);
/*static */ void update_model (ac_model *, int);

//ory DMLAB 
//value length ̸ŭ Ʈ  ڿ ƮƮ ִ Լ
int ac_encode_bits(ac_encoder *ace, ac_model *acm, int value, int length);
int ac_decode_bits(ac_decoder *acd, ac_model *acm, int length);
//~ory DMLAB
#endif
